Index: /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/Client.cs
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/Client.cs	(revision 4927)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/Client.cs	(revision 4927)
@@ -0,0 +1,13 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Services.Authentication.ServiceClients
+{
+   public class Client
+    {
+
+       // like OKBClient
+    }
+}
Index: /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/Application.cs
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/Application.cs	(revision 4927)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/Application.cs	(revision 4927)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Services.Authentication.ServiceClient
+{
+    public partial class Application
+    {
+    }
+}
Index: /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/AuthenticationServiceClient.cs
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/AuthenticationServiceClient.cs	(revision 4927)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/AuthenticationServiceClient.cs	(revision 4927)
@@ -0,0 +1,633 @@
+﻿//------------------------------------------------------------------------------
+// <auto-generated>
+//     This code was generated by a tool.
+//     Runtime Version:4.0.30319.1
+//
+//     Changes to this file may cause incorrect behavior and will be lost if
+//     the code is regenerated.
+// </auto-generated>
+//------------------------------------------------------------------------------
+
+namespace HeuristicLab.Services.Authentication.ServiceClient
+{
+    using System.Runtime.Serialization;
+    
+    
+    [System.Diagnostics.DebuggerStepThroughAttribute()]
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
+    [System.Runtime.Serialization.DataContractAttribute(Name="AuthItem", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Authentication.Data" +
+        "Transfer")]
+    [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Services.Authentication.ServiceClient.NamedAuthItem))]
+    [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Services.Authentication.ServiceClient.Role))]
+    [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Services.Authentication.ServiceClient.Application))]
+    [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Services.Authentication.ServiceClient.User))]
+    public partial class AuthItem : object, System.Runtime.Serialization.IExtensibleDataObject, System.ComponentModel.INotifyPropertyChanged
+    {
+        
+        private System.Runtime.Serialization.ExtensionDataObject extensionDataField;
+        
+        private System.Guid IdField;
+        
+        public System.Runtime.Serialization.ExtensionDataObject ExtensionData
+        {
+            get
+            {
+                return this.extensionDataField;
+            }
+            set
+            {
+                this.extensionDataField = value;
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.Guid Id
+        {
+            get
+            {
+                return this.IdField;
+            }
+            set
+            {
+                if ((this.IdField.Equals(value) != true))
+                {
+                    this.IdField = value;
+                    this.RaisePropertyChanged("Id");
+                }
+            }
+        }
+        
+        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
+        
+        protected void RaisePropertyChanged(string propertyName)
+        {
+            System.ComponentModel.PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
+            if ((propertyChanged != null))
+            {
+                propertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
+            }
+        }
+    }
+    
+    [System.Diagnostics.DebuggerStepThroughAttribute()]
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
+    [System.Runtime.Serialization.DataContractAttribute(Name="NamedAuthItem", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Authentication.Data" +
+        "Transfer")]
+    [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Services.Authentication.ServiceClient.Role))]
+    [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Services.Authentication.ServiceClient.Application))]
+    [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Services.Authentication.ServiceClient.User))]
+    public partial class NamedAuthItem : HeuristicLab.Services.Authentication.ServiceClient.AuthItem
+    {
+        
+        private string NameField;
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string Name
+        {
+            get
+            {
+                return this.NameField;
+            }
+            set
+            {
+                if ((object.ReferenceEquals(this.NameField, value) != true))
+                {
+                    this.NameField = value;
+                    this.RaisePropertyChanged("Name");
+                }
+            }
+        }
+    }
+    
+    [System.Diagnostics.DebuggerStepThroughAttribute()]
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
+    [System.Runtime.Serialization.DataContractAttribute(Name="Role", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Authentication.Data" +
+        "Transfer")]
+    public partial class Role : HeuristicLab.Services.Authentication.ServiceClient.NamedAuthItem
+    {
+        
+        private System.Guid ApplicationIdField;
+        
+        private string DescriptionField;
+        
+        private string LoweredRoleNameField;
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.Guid ApplicationId
+        {
+            get
+            {
+                return this.ApplicationIdField;
+            }
+            set
+            {
+                if ((this.ApplicationIdField.Equals(value) != true))
+                {
+                    this.ApplicationIdField = value;
+                    this.RaisePropertyChanged("ApplicationId");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string Description
+        {
+            get
+            {
+                return this.DescriptionField;
+            }
+            set
+            {
+                if ((object.ReferenceEquals(this.DescriptionField, value) != true))
+                {
+                    this.DescriptionField = value;
+                    this.RaisePropertyChanged("Description");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string LoweredRoleName
+        {
+            get
+            {
+                return this.LoweredRoleNameField;
+            }
+            set
+            {
+                if ((object.ReferenceEquals(this.LoweredRoleNameField, value) != true))
+                {
+                    this.LoweredRoleNameField = value;
+                    this.RaisePropertyChanged("LoweredRoleName");
+                }
+            }
+        }
+    }
+    
+    [System.Diagnostics.DebuggerStepThroughAttribute()]
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
+    [System.Runtime.Serialization.DataContractAttribute(Name="Application", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Authentication.Data" +
+        "Transfer")]
+    public partial class Application : HeuristicLab.Services.Authentication.ServiceClient.NamedAuthItem
+    {
+        
+        private string DescriptionField;
+        
+        private string LoweredApplicationNameField;
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string Description
+        {
+            get
+            {
+                return this.DescriptionField;
+            }
+            set
+            {
+                if ((object.ReferenceEquals(this.DescriptionField, value) != true))
+                {
+                    this.DescriptionField = value;
+                    this.RaisePropertyChanged("Description");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string LoweredApplicationName
+        {
+            get
+            {
+                return this.LoweredApplicationNameField;
+            }
+            set
+            {
+                if ((object.ReferenceEquals(this.LoweredApplicationNameField, value) != true))
+                {
+                    this.LoweredApplicationNameField = value;
+                    this.RaisePropertyChanged("LoweredApplicationName");
+                }
+            }
+        }
+    }
+    
+    [System.Diagnostics.DebuggerStepThroughAttribute()]
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
+    [System.Runtime.Serialization.DataContractAttribute(Name="User", Namespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Authentication.Data" +
+        "Transfer")]
+    public partial class User : HeuristicLab.Services.Authentication.ServiceClient.NamedAuthItem
+    {
+        
+        private System.Guid ApplicationIdField;
+        
+        private string CommentField;
+        
+        private System.DateTime CreateDateField;
+        
+        private string EmailField;
+        
+        private bool IsApprovedField;
+        
+        private bool IsLookedOutField;
+        
+        private System.DateTime LastActivityDateField;
+        
+        private System.DateTime LastLockoutDateField;
+        
+        private System.DateTime LastLoginDateField;
+        
+        private System.DateTime LastPasswordChangeDateField;
+        
+        private string PasswordField;
+        
+        private string PasswordSaltField;
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.Guid ApplicationId
+        {
+            get
+            {
+                return this.ApplicationIdField;
+            }
+            set
+            {
+                if ((this.ApplicationIdField.Equals(value) != true))
+                {
+                    this.ApplicationIdField = value;
+                    this.RaisePropertyChanged("ApplicationId");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string Comment
+        {
+            get
+            {
+                return this.CommentField;
+            }
+            set
+            {
+                if ((object.ReferenceEquals(this.CommentField, value) != true))
+                {
+                    this.CommentField = value;
+                    this.RaisePropertyChanged("Comment");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.DateTime CreateDate
+        {
+            get
+            {
+                return this.CreateDateField;
+            }
+            set
+            {
+                if ((this.CreateDateField.Equals(value) != true))
+                {
+                    this.CreateDateField = value;
+                    this.RaisePropertyChanged("CreateDate");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string Email
+        {
+            get
+            {
+                return this.EmailField;
+            }
+            set
+            {
+                if ((object.ReferenceEquals(this.EmailField, value) != true))
+                {
+                    this.EmailField = value;
+                    this.RaisePropertyChanged("Email");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public bool IsApproved
+        {
+            get
+            {
+                return this.IsApprovedField;
+            }
+            set
+            {
+                if ((this.IsApprovedField.Equals(value) != true))
+                {
+                    this.IsApprovedField = value;
+                    this.RaisePropertyChanged("IsApproved");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public bool IsLookedOut
+        {
+            get
+            {
+                return this.IsLookedOutField;
+            }
+            set
+            {
+                if ((this.IsLookedOutField.Equals(value) != true))
+                {
+                    this.IsLookedOutField = value;
+                    this.RaisePropertyChanged("IsLookedOut");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.DateTime LastActivityDate
+        {
+            get
+            {
+                return this.LastActivityDateField;
+            }
+            set
+            {
+                if ((this.LastActivityDateField.Equals(value) != true))
+                {
+                    this.LastActivityDateField = value;
+                    this.RaisePropertyChanged("LastActivityDate");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.DateTime LastLockoutDate
+        {
+            get
+            {
+                return this.LastLockoutDateField;
+            }
+            set
+            {
+                if ((this.LastLockoutDateField.Equals(value) != true))
+                {
+                    this.LastLockoutDateField = value;
+                    this.RaisePropertyChanged("LastLockoutDate");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.DateTime LastLoginDate
+        {
+            get
+            {
+                return this.LastLoginDateField;
+            }
+            set
+            {
+                if ((this.LastLoginDateField.Equals(value) != true))
+                {
+                    this.LastLoginDateField = value;
+                    this.RaisePropertyChanged("LastLoginDate");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.DateTime LastPasswordChangeDate
+        {
+            get
+            {
+                return this.LastPasswordChangeDateField;
+            }
+            set
+            {
+                if ((this.LastPasswordChangeDateField.Equals(value) != true))
+                {
+                    this.LastPasswordChangeDateField = value;
+                    this.RaisePropertyChanged("LastPasswordChangeDate");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string Password
+        {
+            get
+            {
+                return this.PasswordField;
+            }
+            set
+            {
+                if ((object.ReferenceEquals(this.PasswordField, value) != true))
+                {
+                    this.PasswordField = value;
+                    this.RaisePropertyChanged("Password");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public string PasswordSalt
+        {
+            get
+            {
+                return this.PasswordSaltField;
+            }
+            set
+            {
+                if ((object.ReferenceEquals(this.PasswordSaltField, value) != true))
+                {
+                    this.PasswordSaltField = value;
+                    this.RaisePropertyChanged("PasswordSalt");
+                }
+            }
+        }
+    }
+    
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")]
+    [System.ServiceModel.ServiceContractAttribute(ConfigurationName="HeuristicLab.Services.Authentication.ServiceClient.IAuthenticationService")]
+    public interface IAuthenticationService
+    {
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/GetUser", ReplyAction="http://tempuri.org/IAuthenticationService/GetUserResponse")]
+        HeuristicLab.Services.Authentication.ServiceClient.User GetUser(System.Guid id);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/GetUsers", ReplyAction="http://tempuri.org/IAuthenticationService/GetUsersResponse")]
+        HeuristicLab.Services.Authentication.ServiceClient.User[] GetUsers(System.Guid applicationId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/InsertUser", ReplyAction="http://tempuri.org/IAuthenticationService/InsertUserResponse")]
+        bool InsertUser(HeuristicLab.Services.Authentication.ServiceClient.User user);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/DeleteUser", ReplyAction="http://tempuri.org/IAuthenticationService/DeleteUserResponse")]
+        bool DeleteUser(System.Guid id);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/UpdateUser", ReplyAction="http://tempuri.org/IAuthenticationService/UpdateUserResponse")]
+        bool UpdateUser(HeuristicLab.Services.Authentication.ServiceClient.User user);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/AddUserToRole", ReplyAction="http://tempuri.org/IAuthenticationService/AddUserToRoleResponse")]
+        bool AddUserToRole(System.Guid roleId, System.Guid userId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/RemoveUserFromRole", ReplyAction="http://tempuri.org/IAuthenticationService/RemoveUserFromRoleResponse")]
+        bool RemoveUserFromRole(System.Guid roleId, System.Guid userId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/GetRolesForUser", ReplyAction="http://tempuri.org/IAuthenticationService/GetRolesForUserResponse")]
+        HeuristicLab.Services.Authentication.ServiceClient.Role[] GetRolesForUser(System.Guid userId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/GetRole", ReplyAction="http://tempuri.org/IAuthenticationService/GetRoleResponse")]
+        HeuristicLab.Services.Authentication.ServiceClient.Role GetRole(System.Guid id);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/GetRoles", ReplyAction="http://tempuri.org/IAuthenticationService/GetRolesResponse")]
+        HeuristicLab.Services.Authentication.ServiceClient.Role[] GetRoles(System.Guid applicationId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/InsertRole", ReplyAction="http://tempuri.org/IAuthenticationService/InsertRoleResponse")]
+        bool InsertRole(HeuristicLab.Services.Authentication.ServiceClient.Role role);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/UpdateRole", ReplyAction="http://tempuri.org/IAuthenticationService/UpdateRoleResponse")]
+        bool UpdateRole(HeuristicLab.Services.Authentication.ServiceClient.Role role);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/DeleteRole", ReplyAction="http://tempuri.org/IAuthenticationService/DeleteRoleResponse")]
+        bool DeleteRole(System.Guid id);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/GetUsersInRole", ReplyAction="http://tempuri.org/IAuthenticationService/GetUsersInRoleResponse")]
+        HeuristicLab.Services.Authentication.ServiceClient.User[] GetUsersInRole(System.Guid roleId);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/GetApplication", ReplyAction="http://tempuri.org/IAuthenticationService/GetApplicationResponse")]
+        HeuristicLab.Services.Authentication.ServiceClient.Application GetApplication(System.Guid id);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/InsertApplication", ReplyAction="http://tempuri.org/IAuthenticationService/InsertApplicationResponse")]
+        bool InsertApplication(HeuristicLab.Services.Authentication.ServiceClient.Application application);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/DeleteApplication", ReplyAction="http://tempuri.org/IAuthenticationService/DeleteApplicationResponse")]
+        bool DeleteApplication(System.Guid id);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IAuthenticationService/GetApplications", ReplyAction="http://tempuri.org/IAuthenticationService/GetApplicationsResponse")]
+        HeuristicLab.Services.Authentication.ServiceClient.Application[] GetApplications();
+    }
+    
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")]
+    public interface IAuthenticationServiceChannel : HeuristicLab.Services.Authentication.ServiceClient.IAuthenticationService, System.ServiceModel.IClientChannel
+    {
+    }
+    
+    [System.Diagnostics.DebuggerStepThroughAttribute()]
+    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")]
+    public partial class AuthenticationServiceClient : System.ServiceModel.ClientBase<HeuristicLab.Services.Authentication.ServiceClient.IAuthenticationService>, HeuristicLab.Services.Authentication.ServiceClient.IAuthenticationService
+    {
+        
+        public AuthenticationServiceClient()
+        {
+        }
+        
+        public AuthenticationServiceClient(string endpointConfigurationName) : 
+                base(endpointConfigurationName)
+        {
+        }
+        
+        public AuthenticationServiceClient(string endpointConfigurationName, string remoteAddress) : 
+                base(endpointConfigurationName, remoteAddress)
+        {
+        }
+        
+        public AuthenticationServiceClient(string endpointConfigurationName, System.ServiceModel.EndpointAddress remoteAddress) : 
+                base(endpointConfigurationName, remoteAddress)
+        {
+        }
+        
+        public AuthenticationServiceClient(System.ServiceModel.Channels.Binding binding, System.ServiceModel.EndpointAddress remoteAddress) : 
+                base(binding, remoteAddress)
+        {
+        }
+        
+        public HeuristicLab.Services.Authentication.ServiceClient.User GetUser(System.Guid id)
+        {
+            return base.Channel.GetUser(id);
+        }
+        
+        public HeuristicLab.Services.Authentication.ServiceClient.User[] GetUsers(System.Guid applicationId)
+        {
+            return base.Channel.GetUsers(applicationId);
+        }
+        
+        public bool InsertUser(HeuristicLab.Services.Authentication.ServiceClient.User user)
+        {
+            return base.Channel.InsertUser(user);
+        }
+        
+        public bool DeleteUser(System.Guid id)
+        {
+            return base.Channel.DeleteUser(id);
+        }
+        
+        public bool UpdateUser(HeuristicLab.Services.Authentication.ServiceClient.User user)
+        {
+            return base.Channel.UpdateUser(user);
+        }
+        
+        public bool AddUserToRole(System.Guid roleId, System.Guid userId)
+        {
+            return base.Channel.AddUserToRole(roleId, userId);
+        }
+        
+        public bool RemoveUserFromRole(System.Guid roleId, System.Guid userId)
+        {
+            return base.Channel.RemoveUserFromRole(roleId, userId);
+        }
+        
+        public HeuristicLab.Services.Authentication.ServiceClient.Role[] GetRolesForUser(System.Guid userId)
+        {
+            return base.Channel.GetRolesForUser(userId);
+        }
+        
+        public HeuristicLab.Services.Authentication.ServiceClient.Role GetRole(System.Guid id)
+        {
+            return base.Channel.GetRole(id);
+        }
+        
+        public HeuristicLab.Services.Authentication.ServiceClient.Role[] GetRoles(System.Guid applicationId)
+        {
+            return base.Channel.GetRoles(applicationId);
+        }
+        
+        public bool InsertRole(HeuristicLab.Services.Authentication.ServiceClient.Role role)
+        {
+            return base.Channel.InsertRole(role);
+        }
+        
+        public bool UpdateRole(HeuristicLab.Services.Authentication.ServiceClient.Role role)
+        {
+            return base.Channel.UpdateRole(role);
+        }
+        
+        public bool DeleteRole(System.Guid id)
+        {
+            return base.Channel.DeleteRole(id);
+        }
+        
+        public HeuristicLab.Services.Authentication.ServiceClient.User[] GetUsersInRole(System.Guid roleId)
+        {
+            return base.Channel.GetUsersInRole(roleId);
+        }
+        
+        public HeuristicLab.Services.Authentication.ServiceClient.Application GetApplication(System.Guid id)
+        {
+            return base.Channel.GetApplication(id);
+        }
+        
+        public bool InsertApplication(HeuristicLab.Services.Authentication.ServiceClient.Application application)
+        {
+            return base.Channel.InsertApplication(application);
+        }
+        
+        public bool DeleteApplication(System.Guid id)
+        {
+            return base.Channel.DeleteApplication(id);
+        }
+        
+        public HeuristicLab.Services.Authentication.ServiceClient.Application[] GetApplications()
+        {
+            return base.Channel.GetApplications();
+        }
+    }
+}
Index: /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/Role.cs
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/Role.cs	(revision 4927)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/Role.cs	(revision 4927)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Services.Authentication.ServiceClient
+{
+    public partial class Role
+    {
+    }
+}
Index: /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/User.cs
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/User.cs	(revision 4927)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/ServiceClients/User.cs	(revision 4927)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Services.Authentication.ServiceClient
+{
+    public partial class User
+    {
+    }
+}
Index: /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/app.config
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/app.config	(revision 4927)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication.ServiceClients/app.config	(revision 4927)
@@ -0,0 +1,38 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<configuration>
+  <system.serviceModel>
+    <bindings>
+      <wsHttpBinding>
+      
+        <binding name="WSHttpBinding_IAuthenticationService" closeTimeout="00:01:00"
+            openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00"
+            bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard"
+            maxBufferPoolSize="524288" maxReceivedMessageSize="65536"
+            messageEncoding="Text" textEncoding="utf-8" useDefaultWebProxy="true"
+            allowCookies="false">
+          <readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
+              maxBytesPerRead="4096" maxNameTableCharCount="16384" />
+          <reliableSession ordered="true" inactivityTimeout="00:10:00"
+              enabled="false" />
+          <security mode="Message">
+            <transport clientCredentialType="Windows" proxyCredentialType="None"
+                realm="" />
+            <message clientCredentialType="UserName" negotiateServiceCredential="true"
+                algorithmSuite="Default" />
+          </security>
+        </binding>
+      </wsHttpBinding>
+    </bindings>
+    <client>
+     
+      <endpoint address="http://localhost:8732/Design_Time_Addresses/HeuristicLab.Services.Authentication/AuthenticationService"
+          binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IAuthenticationService"
+          contract="HeuristicLab.Services.Authentication.IAuthenticationService"
+          name="WSHttpBinding_IAuthenticationService">
+        <identity>
+          <certificate encodedValue="AwAAAAEAAAAUAAAAD/AlkYJw/OUhl6D/9w8mjJBh39kgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTEwMDgyMDIyMzIwOFoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDPkfCSLRX8/4F+Z4ys43yZ4MMzjB44cMakPz4Nri+mEB5n2z/0GFatCYzkI2f/nniWqVrBYjHkjsZy2EZioHu4wa99c1XEGJnFNDuNn6ESkfEyhyF4+OqKGnpK9HNrw7OWMuqn2oOh0iFd9fl6FTAm+Y0p3LP+38BuYzpCniqqdwIDAQABo0kwRzBFBgNVHQEEPjA8gBDvi8Rgio9v+mr58TiAvqF5oRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQADgYEANdGlvHKeUptfNu9I0wgA5qjmVB+JDldOAkrfM0R+4IcVQ06y5K7P07uxQAV7+rhnDLgLyFJunUHgzbfjsjFy7vjwtoieXA5j0AYlm4AHR7dHt4HVgkIMYt8XOCqMw5jjFX91xJ89tC7mM9zYR48N9T5QSeMGo+f+JzybeLWxnNs=" />
+        </identity>
+      </endpoint>
+    </client>
+  </system.serviceModel>
+</configuration>