Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/App_LocalResources/Images.resx
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/App_LocalResources/Images.resx	(revision 4950)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/App_LocalResources/Images.resx	(revision 4952)
@@ -125,3 +125,6 @@
     <value>..\Resources\Plus.bmp;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
   </data>
+  <data name="Update" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\Update.bmp;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
 </root>
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Content/Site.css
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Content/Site.css	(revision 4950)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Content/Site.css	(revision 4952)
@@ -206,5 +206,4 @@
 input[type="text"] 
 {
-    width: 200px;
     border: 1px solid #CCC;
 }
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/AlgorithmClassController.cs
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/AlgorithmClassController.cs	(revision 4950)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/AlgorithmClassController.cs	(revision 4952)
@@ -16,18 +16,23 @@
         public ActionResult Index() {
             //create list of algorithms
-            OKBService.OKBServiceClient sc = new OKBService.OKBServiceClient();
-            sc.ClientCredentials.UserName.UserName = "Gerhard";
-            sc.ClientCredentials.UserName.Password = "Gerhard";
-            sc.ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.None;
+            //OKBService.OKBServiceClient sc = new OKBService.OKBServiceClient();
+            //sc.ClientCredentials.UserName.UserName = "Gerhard";
+            //sc.ClientCredentials.UserName.Password = "Gerhard";
+            //sc.ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.None;
 
-            var agcList = new List<OKBService.AlgorithmClass>();
-            OKBService.AlgorithmClass[] ac = sc.GetAlgorithmClasses();
-            foreach (OKBService.AlgorithmClass a in ac) {
-                agcList.Add(a);
-            }//foreach
+            //var agcList = new List<OKBService.AlgorithmClass>();
+            //OKBService.AlgorithmClass[] ac = sc.GetAlgorithmClasses();
+            //foreach (OKBService.AlgorithmClass a in ac) {
+            //    agcList.Add(a);
+            //}//foreach
+
+            //var viewModel = new AlgorithmClassModel {
+            //    NumOfClasses = agcList.Count(),
+            //    AlgorithmClassList = agcList
+            //};
 
             var viewModel = new AlgorithmClassModel {
-                NumOfClasses = agcList.Count(),
-                AlgorithmClassList = agcList
+                NumOfClasses = 0,
+                AlgorithmClassList = null
             };
 
@@ -51,4 +56,11 @@
         }//index
 
+        //
+        // GET: /AlgotithmClass/5
+        public string DelAlgorithmClass(int id){
+            string message = "DeleteAlgorithmClass, id = " + Server.HtmlEncode(Request.QueryString["id"]);
+            return Server.HtmlEncode(message);
+        }
+
     }
 }
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/HLWebPluginHost.csproj
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/HLWebPluginHost.csproj	(revision 4950)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/HLWebPluginHost.csproj	(revision 4952)
@@ -138,4 +138,6 @@
     <None Include="Resources\Plus.bmp" />
     <None Include="Resources\Delete.bmp" />
+    <None Include="Resources\Update.bmp" />
+    <Content Include="Scripts\lbAlgorithmClassOnClick.js" />
     <Content Include="Views\AlgorithmClass\Index.aspx" />
     <Content Include="Views\ServicePrototype\Index.aspx" />
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Models/AlgorithmClassModel.cs
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Models/AlgorithmClassModel.cs	(revision 4950)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Models/AlgorithmClassModel.cs	(revision 4952)
@@ -26,5 +26,7 @@
 
             return agcList;
-        }
+        }//AlgorithmClassGetAll
+
+          
     }
 }
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Index.aspx
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Index.aspx	(revision 4950)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Index.aspx	(revision 4952)
@@ -1,7 +1,17 @@
 ﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<dynamic>" %>
+
+<script runat="server">
+
+    void lbAlgorithmClassOnClick(object sender, EventArgs e) {
+      txtName.Text = "aaa";
+   }
+
+</script>
+
 
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
 	Index
 </asp:Content>
+    
 
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
@@ -9,21 +19,48 @@
     <form id="form1" runat="server">
 
+
     <h2>AlgorithmClasses</h2>
+    
+    <%--<ul>
+        <%foreach (HLWebPluginHost.OKBService.AlgorithmClass ac in Model.AlgorithmClassList) { %>
+            <li>
+                <%: ac.Name %>
+            </li>
+        <%} %>
+    </ul>--%>
+    
     <asp:Panel ID="Panel1" runat="server">
-        <asp:ImageButton ID="ImageButton1" runat="server" 
-            ImageUrl="~/Resources/Plus.bmp" ToolTip="Add Class" />
-        <asp:ImageButton ID="ImageButton2" runat="server" 
-            ImageUrl="~/Resources/Delete.bmp" ToolTip="Delete Class" />
+        <asp:ImageButton ID="btnAddAlgorithmClass" runat="server" 
+            ImageUrl="~/Resources/Plus.bmp" ToolTip="Add Class" BorderColor="Black" 
+            CommandArgument="Id" CommandName="AddAlgorithmClass" />
+        <asp:ImageButton ID="btnDeleteAlgorithmClass" runat="server" 
+            ImageUrl="~/Resources/Delete.bmp" ToolTip="Delete Class" 
+            CommandArgument="Id" CommandName="lgorithmClass" />
+        <asp:ImageButton ID="btnUpdateAlgorithmClass" runat="server" 
+            CommandArgument="Id" CommandName="UpdAlgorithmClass" 
+            ImageUrl="~/Resources/Update.bmp" />
     </asp:Panel>
     <p>
-        <asp:ListBox ID="ListBox1" runat="server" DataSourceID="ODSAlgorithmClasses" 
+        <asp:ListBox ID="lbAlgorithmClass" runat="server" DataSourceID="ODSAlgorithmClasses" 
             DataTextField="Name" DataValueField="Id" Height="350px" style="margin-top: 0px" 
-            Width="246px"></asp:ListBox>
+            Width="246px">
+        </asp:ListBox>
         <asp:ObjectDataSource ID="ODSAlgorithmClasses" runat="server" 
             SelectMethod="AlgorithmClassGetAll" 
             TypeName="HLWebPluginHost.Models.AlgorithmClassModel">
         </asp:ObjectDataSource>
+        <asp:Button ID="Button1" Text="Select" OnClick="lbAlgorithmClassOnClick" runat="server"/>
+
     </p>
+   
 
+    <asp:Panel ID="Panel2" runat="server" Height="139px">
+        <asp:Label ID="lbName" runat="server" Text="Name:"></asp:Label>
+        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
+        <asp:TextBox ID="txtName" runat="server" Width="197px"></asp:TextBox>
+        <br />
+        Description:
+        <asp:TextBox ID="txtDescription" runat="server" Width="197px"></asp:TextBox>
+    </asp:Panel>
    
 