Index: branches/ClientManagement/HeuristicLab.Services.Authentication/Test/Program.cs
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/Test/Program.cs	(revision 4732)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/Test/Program.cs	(revision 4953)
@@ -3,5 +3,7 @@
 using System.Linq;
 using System.Text;
-using HeuristicLab.Services.Authentication.DataAccess;
+using HeuristicLab.Services.Authentication;
+using DA = HeuristicLab.Services.Authentication.DataAccess;
+using DT = HeuristicLab.Services.Authentication.DataTransfer;
 
 namespace Test
@@ -12,17 +14,22 @@
         {
 
-            ClientManagmentDataContext dc = new ClientManagmentDataContext(@"Data Source=nb-1\sqlexpress;Initial Catalog=HeuristicLab.ClientManagment;Integrated Security=SSPI;");
-          
-            if (dc.DatabaseExists()) {
-              Console.WriteLine("DB exsits");
-              dc.DeleteDatabase();
-              Console.WriteLine("DB deleted");
+            //DA.ClientManagmentDataContext dc = new DA.ClientManagmentDataContext(@"Data Source=.\SQL2008;Initial Catalog=HeuristicLab.ClientManagment;Integrated Security=True");
+            DA.ClientManagmentDataContext dc = new DA.ClientManagmentDataContext();
+
+            if (dc.DatabaseExists())
+            {
+                Console.WriteLine("DB exsits");
+                dc.DeleteDatabase();
+                dc.SubmitChanges();
+                Console.WriteLine("DB deleted");
             }
             Console.WriteLine("DB create");
             dc.CreateDatabase();
+            dc.SubmitChanges();
             Console.WriteLine("Finished");
-                     
-            
-            Client c = new Client();
+
+            ClientService cs = new ClientService();
+
+            DT.Client c = new DT.Client();
 
             c.Id = Guid.NewGuid();
@@ -30,21 +37,31 @@
             c.Description = "Development-PC";
             c.IPAdress = "192.168.0.1";
+
             //c.ResourceType = "Client";
-            ResourceGroup r = new ResourceGroup();
+            DT.ResourceGroup r = new DT.ResourceGroup();
             r.Name = "test";
 
-            ResourceResourceGroup rrg = new ResourceResourceGroup();
-            rrg.ResourceGroup = r;
-            rrg.Client = c;
+            r.Id = cs.AddResourceGroup(r);
+
+            c.ResourceGroup = r.Id;
+            c.Id = cs.AddClient(c);
+           
+            //ResourceResourceGroup rrg = new ResourceResourceGroup();
+            //rrg.ResourceGroup = r;
+            //rrg.Client = c;
             
             
-            dc.GetTable<Resource>().InsertOnSubmit(r);
-            dc.GetTable<Resource>().InsertOnSubmit(c);
+            //dc.GetTable<Resource>().InsertOnSubmit(r);
+            //dc.GetTable<Resource>().InsertOnSubmit(c);
 
-            dc.GetTable<ResourceResourceGroup>().InsertOnSubmit(rrg);
+            //dc.GetTable<ResourceResourceGroup>().InsertOnSubmit(rrg);
 
-            dc.SubmitChanges();
+            //dc.SubmitChanges();
 
+           
+           // cs.GetClients();
 
+            //cs.DeleteClient(c);
+           cs.DeleteResourceGroup(r);
 
 
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/Test/Test.csproj
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/Test/Test.csproj	(revision 4732)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/Test/Test.csproj	(revision 4953)
@@ -53,4 +53,12 @@
       <Name>HeuristicLab.Services.Authentication.DataAccess</Name>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Services.Authentication.DataTransfer\HeuristicLab.Services.Authentication.DataTransfer.csproj">
+      <Project>{73E5113E-A293-4384-8B16-3CE38F2CFDC9}</Project>
+      <Name>HeuristicLab.Services.Authentication.DataTransfer</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Services.Authentication\HeuristicLab.Services.Authentication.csproj">
+      <Project>{ED8DC6E8-57C6-49E0-8CDF-25703AC52350}</Project>
+      <Name>HeuristicLab.Services.Authentication</Name>
+    </ProjectReference>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />