Index: /branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.sln
===================================================================
--- /branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.sln	(revision 4957)
+++ /branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.sln	(revision 4958)
@@ -10,5 +10,17 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "Test", "Test\Test.csproj", "{D83C93B5-5DDE-4A66-A9B8-D7FD0A891ABB}"
 EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "TestWebService", "TestWebService\TestWebService.csproj", "{01C496AF-00BE-4C51-9AA1-A9EBBE780003}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{762DA386-BCEE-4788-A676-A7883FBA3D28}"
+	ProjectSection(SolutionItems) = preProject
+		HeuristicLab.Services.Authentication.vsmdi = HeuristicLab.Services.Authentication.vsmdi
+		Local.testsettings = Local.testsettings
+		TraceAndTestImpact.testsettings = TraceAndTestImpact.testsettings
+	EndProjectSection
+EndProject
 Global
+	GlobalSection(TestCaseManagementSettings) = postSolution
+		CategoryFile = HeuristicLab.Services.Authentication.vsmdi
+	EndGlobalSection
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
 		Debug|Any CPU = Debug|Any CPU
@@ -60,4 +72,14 @@
 		{D83C93B5-5DDE-4A66-A9B8-D7FD0A891ABB}.Release|x86.ActiveCfg = Release|x86
 		{D83C93B5-5DDE-4A66-A9B8-D7FD0A891ABB}.Release|x86.Build.0 = Release|x86
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Release|Any CPU.Build.0 = Release|Any CPU
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Release|Mixed Platforms.ActiveCfg = Release|Any CPU
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Release|Mixed Platforms.Build.0 = Release|Any CPU
+		{01C496AF-00BE-4C51-9AA1-A9EBBE780003}.Release|x86.ActiveCfg = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /branches/ClientManagement/HeuristicLab.Services.Authentication/Test/Program.cs
===================================================================
--- /branches/ClientManagement/HeuristicLab.Services.Authentication/Test/Program.cs	(revision 4957)
+++ /branches/ClientManagement/HeuristicLab.Services.Authentication/Test/Program.cs	(revision 4958)
@@ -17,15 +17,15 @@
             DA.ClientManagmentDataContext dc = new DA.ClientManagmentDataContext();
 
-            if (dc.DatabaseExists())
-            {
-                Console.WriteLine("DB exsits");
-                dc.DeleteDatabase();
-                dc.SubmitChanges();
-                Console.WriteLine("DB deleted");
-            }
-            Console.WriteLine("DB create");
-            dc.CreateDatabase();
-            dc.SubmitChanges();
-            Console.WriteLine("Finished");
+            //if (dc.DatabaseExists())
+            //{
+            //    Console.WriteLine("DB exsits");
+            //    dc.DeleteDatabase();
+            //    dc.SubmitChanges();
+            //    Console.WriteLine("DB deleted");
+            //}
+            //Console.WriteLine("DB create");
+            //dc.CreateDatabase();
+            //dc.SubmitChanges();
+            //Console.WriteLine("Finished");
 
             ClientService cs = new ClientService();
Index: /branches/ClientManagement/HeuristicLab.Services.Authentication/TestWebService/TestWebService.csproj
===================================================================
--- /branches/ClientManagement/HeuristicLab.Services.Authentication/TestWebService/TestWebService.csproj	(revision 4957)
+++ /branches/ClientManagement/HeuristicLab.Services.Authentication/TestWebService/TestWebService.csproj	(revision 4958)
@@ -7,5 +7,5 @@
     </ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
-    <ProjectGuid>741f1630-a465-47ad-979b-0a15847bd4bd</ProjectGuid>
+    <ProjectGuid>{01C496AF-00BE-4C51-9AA1-A9EBBE780003}</ProjectGuid>
     <OutputType>Library</OutputType>
     <AppDesignerFolder>Properties</AppDesignerFolder>
@@ -34,4 +34,5 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="Microsoft.VisualStudio.QualityTools.UnitTestFramework, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL" />
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -46,4 +47,11 @@
   <ItemGroup>
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="TestWebServiec.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Services.Authentication\HeuristicLab.Services.Authentication.csproj">
+      <Project>{ED8DC6E8-57C6-49E0-8CDF-25703AC52350}</Project>
+      <Name>HeuristicLab.Services.Authentication</Name>
+    </ProjectReference>
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />